%%% Local Variables:
%%% mode: latex
%%% TeX-master: "main"
%%% End:

\chapter{Primitives}

\section{Primitives module}

Virtual machine primitives are exposed as methods on a unique object
called the \emph{primitives module}. This is a different approach to
many Smalltalk descendents, which expose primitives as ``annotations''
on methods \cite[p.~563]{blue-book}. Exposing primitives using this approach
allows for using object-capabilities for encapsulation of primitives, and
frees compilers targeting the Utena virtual machine from wasting effort
to specifically handle primitives in implementation code, when
primitives cannot be used by user code.

\section{Message Constant Table} \label{section:primitives:constant-table}

The message constant table
contains message selectors which are frequently used by the primitives
provided in this VM, and is used to save space in method for literals,
as they would be repeated several times, yet they are common among
many methods.

\textbf{TODO: of course, this table will remain incomplete until
all the primitives have been specified.}